#
# Work Orders Product
#
# (C) Copyright 2000,2001 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
# All Rights Reserved
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>

import App, Globals, OFS
import string
from Globals import HTMLFile, HTML
from Acquisition import Implicit
from OFS.SimpleItem import SimpleItem

manage_addEngineerForm=HTMLFile('Engineers/manage_addEngineerForm',globals())

def manage_addEngineer(self, engineer_login, engineer_password,
                       engineer_name, engineer_email,connection,
                       REQUEST={}):
    """ Engineer Meta-Constructor """
    obj=Engineer(engineer_login, engineer_name, engineer_email,
                 connection)

    # Add it to the nearest acl_users folder...
    try:
        acl_users=getattr(self,'acl_users')
        acl_users._addUser(name=engineer_login, password=engineer_password,
                           confirm=engineer_password,domains=[],
                           roles=['Engineer',])
    except:
		import traceback
		traceback.print_exc()
		return

	acl_users.currentPropSource.setUserProperty(key='realname',
												username=engineer_login,
												value=engineer_name)
	
	acl_users.currentPropSource.setUserProperty(key='email',
												username=engineer_login,
												value=engineer_email)

    # Stuff it in the database
    realConnection=getattr(self,connection)
    realConnection().query(EngineerInsertQuery%(
        engineer_login, engineer_email, engineer_name))

    if REQUEST:
        return self.manage_main(self,REQUEST)

    
EngineerInsertQuery="""
INSERT INTO Engineers (login, email, name)
VALUES ('%s', '%s', '%s')
"""

EngineerUpdateQuery="""
UPDATE Engineers SET
name='%s', email='%s'
WHERE login='%s'
"""

# This is a non-persistent class item
# It will disappear and re-appear at random.
# The point being it might still be around, so we do keep
# stuff internally.

class Engineer(SimpleItem,Implicit):
    """
    Define an Engineer to the world
    """

    manage_edit=HTMLFile('Engineers/manage_editEngineerForm',globals())

    meta_type='Wifl Engineer'
    
    # We don't keep the password...
    def __init__(self,login,name,email,connection):
        self.engineerLogin=login
        self.engineerEmail=email
        self.connection=connection
        self.engineerName=name

    # We need the password here to send off to edit_users...
    def manage_editEngineer(self, engineerLogin, engineerName,
                            engineerEmail, engineerPassword,
                            REQUEST={}):
        """ Edit an Engineer """
        self.engineerLogin=engineerLogin
        self.engineerMail=engineerEmail
        self.engineerName=engineerName

        acl_users=getattr(self,'acl_users')
        acl_users._changeUser(name=engineerLogin,
                              password=engineerPassword,
                              confirm=engineerPassword,
                              domains=[],
                              roles=['Engineer',])

        # The db might not have transactions,
        # do this last.
        realConnection=getattr(self,connection)
        realConnection().query(EngineerInsertQuery%(
            self.name, self.email, self.login))

        if REQUEST:
            return self.manage_edit(self,REQUEST)
