#
# Work Orders Product
#
# (C) Copyright 2000,2001 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
# All Rights Reserved
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>

import App, Globals, OFS
import string
from Products.ZSQLMethods.SQL import SQL
from Globals import HTMLFile, HTML

from OFS.Folder import Folder
from OFS.DTMLMethod import DTMLMethod

class WorkOrderState(Folder):
	meta_type='Work Order State'

	def __init__(self, id, connection, noun, verb, toTransitions,
				 fromTransitions, roles):
		self.id=id
		self.connection=connection
		self.noun=noun
		self.verb=verb
		self.roles

		preStateChange=DTMLMethod()
		preStateChange.manage_edit(data='<dtml-comment>Before Change</dtml-comment>', title='Pre State Change')
		self._setObject('preStateChange', preStateChange)

		stateChange=DTMLMethod()
		stateChange.manage_edit(data='<dtml-comment>Change State</dtml-comment>', title='State Change')
		self._setObject('stateChange', stateChange)

		postStateChange=DTMLMethod()
		postStateChange.manage_edit(data='<dtml-comment>After Change</dtml-comment>', title='Post State Change')
		self._setObject('postStateChange', postStateChange)
		
		
	# Methods to protect against people deleting the DTML Methods or
	# Forgetting to implement them
	def PreStateChange(self):
		""" Pre State Change """
		if 'preStateChange' in self.objectIds():
			self.preStateChange()

	def StateChange(self):
		""" Change the State """
		if 'stateChange' in self.objectIds():
			self.stateChange()

	def PostStateChange(self):
		""" Post State Change """
		if 'postStateChange' in self.objectIds():
			self.postStateChange()
	
	
